<template>
  <q-page>
    <div class="row justify-center my-5">

      <q-input v-if="!showCreatedCard" @click="showCreatedCard = !showCreatedCard" standout="bg-white"
               class="w-500" outlined v-model="formCreate.content" label="Crear una nota"/>
      <FormComponent @close="closeCreateNote()" v-else></FormComponent>

    </div>
    <div class="q-pa-md  items-start q-gutter-md" v-if="notes.pinned">
      <span
        style="font-family: Roboto, Arial, sans-serif;" class="text-grey">FIJADAS</span>
      <div style="margin-bottom: 35px" class="row items-start q-gutter-md">
        <div v-for="note in notes.pinned" :key="note.id">

          <CardShowNote @click="showModalUpdate(note)" @update="getNotes()" :data="note"></CardShowNote>
        </div>

      </div>
    </div>
    <div class="q-pa-md  items-start q-gutter-md" v-if="notes.unpinned">
      <span style="font-family: Roboto, Arial, sans-serif;" class="text-grey">OTRAS</span>
      <div style="margin-bottom: 35px" class="row items-start q-gutter-md">
        <div v-for="note in notes.unpinned" :key="note.id">

          <CardShowNote @click="showModalUpdate(note)" @update="getNotes()" :data="note"></CardShowNote>
        </div>

      </div>
    </div>
    <div class="q-pa-lg flex flex-center">
      <q-pagination
        v-model="pagination.current_page"
        :max="pagination.last_page"
        input
        input-class="text-orange-10"
      />
    </div>
  </q-page>

  <q-dialog @hide="showModal = false" v-model="showModal">
    <FormComponent @close="closeModalUpdate()" action="update" :note-information="formUpdate"></FormComponent>
  </q-dialog>

</template>

<script>
import {defineComponent, ref} from 'vue'
import {apiUrl} from "src/config";
import axios from 'axios'
import FormComponent from "components/notes/FormComponent.vue";
import CardShowNote from "components/notes/CardShowNote.vue";

export default {
  name: 'IndexPage',
  components: {CardShowNote, FormComponent},
  data() {
    return {
      showCreatedCard: false,
      notes: ref([]),
      formCreate: {
        title: '',
        content: '',
        has_pin: false,
        is_archived: false,
      },
      formUpdate: {},
      apiUrl: apiUrl,
      showModal: false,
      pagination: {
        current_page: 1,
        last_page: 1,
        prev_page_url: 1,
        next_page_url: 1
      }
    }
  },
  methods: {
    showModalUpdate(note) {
      this.formUpdate = note;
      this.showModal = true;
    },
    closeModalUpdate() {
      this.showModal = false;
      this.notes = [];
      this.getNotes();
    },
    getNotes(page = this.pagination.current_page) {
      axios.get(this.apiUrl + 'notes?page=' + page).then(res => {
        this.notes = this.separateNotes(res.data.notes);
        this.pagination = res.data.pagination;


      }).catch(err => {
        console.error(err)
      })
    },

    closeCreateNote() {
      this.showCreatedCard = false;
      this.formCreate = {
        title: '',
        content: '',
        has_pin: false,
        is_archived: false,
      }

      this.getNotes();
    },
    separateNotes(notes = []) {
      let notesTypes = {pinned: [], unpinned: []};
      notes.forEach((element) => {
        if (element.has_pin === 1) {
          notesTypes.pinned.push(element)
        } else {
          notesTypes.unpinned.push(element)
        }
      })

      return notesTypes;

    },


  },
  watch: {
    'pagination.current_page': function (newPage, oldPage) {
      this.getNotes(newPage);
    }
  },
  mounted() {
    this.getNotes();
  }

}

</script>
<style>
.card-container {
  display: flex;
  flex-direction: column;
  align-items: stretch;
}
.card-container + .card-container {
  margin-top: 1rem;
}
</style>
